#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "grafo.h"
#include "grafico.h"


grafico::grafico()
{
	cout<<"Ha entrado en el constructor grafico"<<endl;
   Inicializacion_modo_grafico();
}

grafico::~grafico()
{
	cout<<"Ha entrado en el destructor grafico"<<endl;
}

void grafico::Inicializacion_modo_grafico(void)
{
  int xasp, yasp;                       		/* Variables para almacenar el aspecto*/

  GraphDriver = DETECT;                   	/* Deteccin del modo grfico         */
  initgraph( &GraphDriver, &GraphMode, "" );
  ErrorCode = graphresult();	            	/* Resultado de la inicializacion     */
  if( ErrorCode != grOk )	               	/* Posible error en inicializacion    */
	{
    printf(" Error al iniciliacizar el modo grfico: %s\n", grapherrormsg( ErrorCode ) );
    exit( 1 );
  	}

  getpalette( &palette );               /* Lectura de la paleta de colores    */
  MaxColors = getmaxcolor() + 1;        /* Mximo nmero de coloares posibles */

  MaxX = getmaxx();
  MaxY = getmaxy();                     /* Lectura del tamao de la pantalla  */

  getaspectratio( &xasp, &yasp );       /* Lectrua del aspecto del hardware   */
  AspectRatio = (double)xasp / (double)yasp; /*Obteccin de correccin del factor */

}

/* Inicializacion raton */

int grafico::IniciarRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x00;
  intr(0x33,&Registros);
  if (Registros.r_ax==0xffff)
     return (1);  /*Si Existe  */
  else
     return(0);   /*No existe */
}


/* Visualiza el raton en pantalla */

void grafico::MostrarRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x01;
  intr(0x33,&Registros);
}


/* Oculta el raton */

void grafico::OcultarRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x02;
  intr(0x33,&Registros);
}

/* Devuelve una pulsacin del ratn */

int grafico::BotonesRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x03;
  intr(0x33,&Registros);
  return(Registros.r_bx);
}

/* Devuelve la posicion X de pulsacion del raton */

int grafico::PosXRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x03;
  intr(0x33,&Registros);
  return(Registros.r_cx);
}

/* Devuelve la posicion Y de pulsacion del raton */

int grafico::PosYRaton(void)
{
  struct REGPACK Registros;
  Registros.r_ax=0x03;
  intr(0x33,&Registros);
  return(Registros.r_dx);
}

/* Analisis de pulsaciones */

void grafico::tratar_raton(void)
{
  int pulsado;

  /* Esperar para limpieza pulsacion antigua */
  pulsado=1;
  while (pulsado!=0) pulsado=BotonesRaton();

  /* Captura de nueva pulsacin */
  pulsado=0;
  while (pulsado==0)
	 if (BotonesRaton())
	    {
	     col_raton=PosXRaton();
	     fil_raton=PosYRaton();
	     pulsado=1;
	    }
}


/* Analisis de zona de la pantalla pulsada */

int grafico::esperarpulsacion()
{
  int validacion;
  validacion=0;

  while (validacion==0)
	{
	 tratar_raton();
	 if ((col_raton>=70)&&(col_raton<=140))
    {
	    if ((fil_raton>=200)&&(fil_raton<=250)) validacion=1;
    }

    if ((col_raton>=200)&&(col_raton<=270)) {
	    if ((fil_raton>=100)&&(fil_raton<=150)) validacion=2;
       if ((fil_raton>=300)&&(fil_raton<=350)) validacion=6;
    }

    if ((col_raton>=370)&&(col_raton<=440)) {
	    if ((fil_raton>=100)&&(fil_raton<=150)) validacion=3;
       if ((fil_raton>=300)&&(fil_raton<=350)) validacion=5;
    }

  	 if ((col_raton>=500)&&(col_raton<=570))
    {
	    if ((fil_raton>=200)&&(fil_raton<=250)) validacion=4;
    }

    /* Botn salir */
	 if ((col_raton>=270)&&(col_raton<=370))
	    if ((fil_raton>=420)&&(fil_raton<=470)) validacion=7;

	 if (validacion==0)
	    {
	     sound(300);
	     delay(100);
	     nosound();
	    }
	}
   return(validacion);
}

void grafico::borramenu()
{
	OcultarRaton();

  	setfillstyle(SOLID_FILL,BLACK);
  	bar(0,0,640,480);
}

void grafico::pintainstr()
{
   OcultarRaton();

  	setfillstyle(SOLID_FILL,BLACK);
  	setcolor(WHITE);

  	bar(0,0,640,480);

  	setfillstyle(SOLID_FILL,GREEN);

  	/* Cuadros del men */
  	bar(50,50,590,400);
  	bar(50,10,590,45);

  	setfillstyle(SOLID_FILL,RED);

  	/* Tipo de letra utilizada */
  	settextstyle(1, HORIZ_DIR, 3);

  	bar(51,11,589,44);
   outtextxy(240,10,"Instrucciones");

  	settextstyle(7, HORIZ_DIR, 1);
  	outtextxy(70,60,"Bienvenido al juego, al seleccionear jugar se pedira ");
  	outtextxy(70,80,"su nombre y nacionalidad, para pasar de pantalla ");
  	outtextxy(70,100,"y elegir con el raton el monumento que desea visitar.");
  	outtextxy(70,120,"Durante la carrera debe esquivar los obstaculos y ");
   outtextxy(70,140,"coger las bonificaciones, representadas asi: ");

   figura * r;
	r=new rectangulo(70,175,4,85,190);
   r->pintar();
   delete r;

  	setcolor(WHITE);
   outtextxy(90,170,"= bache, pierdes una rueda si no tienes repuesto");

   figura * re;
	re=new rectangulo(70,195,5,100,210);
   re->pintar();
   delete re;

  	setcolor(WHITE);
   outtextxy(105,190,"= accidente, inmoviliza el vehiculo un tiempo");

  	figura * c;
	c=new circulo(80,223,8,8);
   c->pintar();
   delete c;

  	setcolor(WHITE);
   outtextxy(95,210,"= estatua, rueda de repuesto en caso de baches");

   figura * v;
	v=new elipse(85,243,3,120,60,15,8);

   v->pintar();
   delete v;

  	setcolor(WHITE);
   outtextxy(105,230,"= vasija, rellena el deposito de gasolina");

   outtextxy(70,260,"Si consigue superar 1000 puntos durante el juego");
   outtextxy(70,280,"sera recompensado con un coche mas rapido, el cual");
	outtextxy(70,300,"puede desplazarse horizontal y verticalmente.");
	outtextxy(70,320,"Para desplazar el coche debe usar las teclas de ");
	outtextxy(70,340,"de direccion del teclado (flechas).");
	outtextxy(70,360,"Puede avandonar la partida pulsando la tecla Esc.");

   setcolor(RED);
	outtextxy(250,420,"Pulse ENTER para continuar -->");

   getchar();

  	borramenu();

}

int grafico::esperarseleccion()
{
  int seleccion;
  seleccion=0;

  while (seleccion==0)
	{
	 tratar_raton();
	 if ((col_raton>=200)&&(col_raton<=440))
    {
	    if ((fil_raton>=100)&&(fil_raton<=150)) seleccion=1;
  	    if ((fil_raton>=200)&&(fil_raton<=250)) seleccion=2;
	    if ((fil_raton>=300)&&(fil_raton<=350)) seleccion=3;
    }
    /* Botn salir */
	 if ((col_raton>=270)&&(col_raton<=370))
	    if ((fil_raton>=420)&&(fil_raton<=470)) seleccion=4;

	 if (seleccion==0)
	    {
	     sound(300);
	     delay(100);
	     nosound();
	    }
	}
   return(seleccion);
}

void grafico::pintamenu()
{
  OcultarRaton();

  setfillstyle(SOLID_FILL,BLACK);
  setcolor(WHITE);

  bar(0,0,640,480);

  setfillstyle(SOLID_FILL,GREEN);

  /* Cuadros del men */
  bar(50,50,590,400);
  bar(50,10,590,45);

  setfillstyle(SOLID_FILL,RED);

  /* fila 1 de botones */
  bar(200,100,440,150);

  /* fila 2 de botones */
  bar(200,200,440,250);

  /* fila 3 de botones */
  bar(200,300,440,350);

  /*Botn salir */
  bar(285,420,355,470);

  /* Tipo de letra utilizada */
  settextstyle(7, HORIZ_DIR, 1);

  /*texto fila de botones 1 */
  outtextxy(230,110,"Instrucciones de uso");

  /*texto fila de botones 2 */
  outtextxy(233,210,"Jugar una partida");

  /*texto fila de botones 3 */
  outtextxy(223,310,"Busqueda de turistas");

  /*texto botn salir*/
  outtextxy(300,430,"Salir");

  bar(51,11,589,44);
  outtextxy(60,13,"Seleccione la accion que desea realizar: ");

  /*Inicializacin del ratn*/
  IniciarRaton();
  MostrarRaton();

}

void grafico::pintagrafo(grafo *gr2)
{
  char *toyaki;
  toyaki=new char[strlen(gr2->get_p_origen())];
  strcpy(toyaki,gr2->get_p_origen());

  OcultarRaton();

  setfillstyle(SOLID_FILL,BLACK);
  setcolor(WHITE);

  bar(0,0,640,480);

  setfillstyle(SOLID_FILL,GREEN);

  /* Cuadros del men */
  bar(50,50,590,400);
  bar(50,10,590,45);

  gr2->pintar_arcos();

  setfillstyle(SOLID_FILL,RED);

  /* fila 1 de botones */
  bar(200,100,270,150);
  bar(370,100,440,150);

  /* fila 2 de botones */
  bar(70,200,140,250);
  bar(500,200,570,250);

  /* fila 3 de botones */
  bar(200,300,270,350);
  bar(370,300,440,350);

  /*Botn salir */
  bar(285,420,355,470);

  /* Tipo de letra utilizada */
  settextstyle(7, HORIZ_DIR, 1);

  /*texto fila de botones 1 */
  outtextxy(205,110,"Alkzba");
  outtextxy(375,110,"Colum");

  /*texto fila de botones 2 */
  outtextxy(75,210,"O. Tur.");
  outtextxy(505,210,"Teatro");

  /*texto fila de botones 3 */
  outtextxy(205,310,"Diana");
  outtextxy(375,310,"Acue.M");

  /*texto botn salir*/
  outtextxy(300,430,"Salir");

  bar(51,11,589,44);
  outtextxy(60,15,toyaki);

  /*Inicializacin del ratn*/
  IniciarRaton();
  MostrarRaton();

}

