#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include "arbol.h"

arbol::arbol()
{
   //cout<<"constructor arbol sin parmetrizar"<<endl;
   //getchar();
   arbol=NULL;
}

arbol::arbol(pnodo aux)
{
	cout<<"constructor arbol parmetrizado"<<endl;
   getchar();
   arbol=aux;
}

bool arbol::insertar (turista *t)
/* Recorremos el arbol para asegurarnos que el turista no est repetido.
   Si est, no lo insertaremos y finaliza, si no est lo introducimos */
{
 	cout<<"InSerTandO TurIstA "<<t->get_nombre()<<" de "<<t->get_nacionalidad()<<" en El aRbol"<<endl;


   padre=NULL;
  	actual=arbol;

	if ((nuevo = new nodo) == NULL)
   		{
        		cout <<"Error en la asignacion de memoria en un nuevo turista";
            getchar();
        		exit (0);
     		}

   nuevo->giri=t;
   nuevo->izq=NULL;
   nuevo->der=NULL;

	if (vacio(arbol))
    	{
     		//cout<<"Insertando primer elemento del arbol..."<<endl;
			arbol=nuevo;
    	}
   else
    	{
      	while ( (!vacio (actual)) && (strcmp(t->get_nombre(),actual->giri->get_nombre())!=0) )
       	/* Recorremos el arbol hasta el final (actual=NULL) o hasta que encontremos el turista. */
     			{
        			padre=actual;
        			if     (strcmp ( t->get_nombre(), actual->giri->get_nombre() ) < 0)	actual=actual->izq;
             	else if(strcmp ( t->get_nombre(), actual->giri->get_nombre() ) > 0)  actual=actual->der;
				}

     		if ((!vacio (actual)) && (strcmp(t->get_nombre(),actual->giri->get_nombre())==0))			//(*t==*actual->giri))
        	/* Hemos parado antes de llegar al final. Se encontr turista */
     			{
     				cout<<"El turista "<<t->get_nombre()<<" ya existe."<<endl;
               return false;
     			}

        	else if (strcmp ( t->get_nombre(), padre->giri->get_nombre() ) < 0)
        	/* El elemento nuevo ser el hijo izquierdo */
     			{
     				//cout<<"Es hijo izquierdo..."<<endl;
        			padre->izq=nuevo;
           		return true;
				}

				else if (strcmp ( t->get_nombre(), padre->giri->get_nombre() ) > 0)
        		/* El elemento nuevo ser el hijo derecho */
     				{
	        			//cout<<"Es hijo derecho..."<<endl;
     		   		padre->der=nuevo;
        		 		return true;
					}

            	else if (strcmp(t->get_nombre(),actual->giri->get_nombre())==0)
               	{
                  	cout<<"tienen = nombre y distinta nacionalidad"<<endl;
                     getchar;
                  }
      }
}

bool arbol::borrar (turista *t)
/* Sustituye el nodo borrado por la hoja ms a la derecha del subarbol izquierdo */
   {
   	cout<<"Borrando turista "<<t->get_nombre()<<" del arbol ..."<<endl;
   	getchar();

   	pnodo aux=arbol;
   	pnodo c, ant;
      cout<<t->get_nombre()<<endl;
		cout<<aux->giri->get_nombre()<<endl;
      cout<<strcmp (t->get_nombre(),aux->giri->get_nombre())<<endl;
      getchar();
      if (aux == NULL) return false;	//arbol vaco
      else if (strcmp (t->get_nombre(),aux->giri->get_nombre())<1)	hijoizq().borrar (t);
      else if (strcmp (t->get_nombre(),aux->giri->get_nombre())>1) 	hijoder().borrar (t);
      else
      {
         c=aux;
         if (aux->izq == NULL)		aux=aux->der;
         else if (aux->der == NULL) aux=aux->izq;
      	else
         {
         	ant=aux;
            c=aux->izq;
            while (c->der != NULL)
            {
            	ant=c;
               c=c->der;
            }
            strcpy(c->giri->get_nombre(),aux->giri->get_nombre());
            if (ant == aux)	aux->izq = c->izq;
            else ant->der = c->izq;
         }
         delete c;
         return true;
      }
      return false;
   }

arbol arbol::hijoizq ()
{
   return (arbol->izq);
}

arbol arbol::hijoder ()
{
  	return (arbol->der);
}

bool arbol::vacio (pnodo aux)
// Devuelve cierto si es el nodo est vacio
{
   return (aux == NULL);
}

void arbol::mostrar ()
/* Muestra el recorrido En Orden del arbol  */
{
   inorden (arbol);
}

void arbol::buscar (char *mm, char *aa)
/* Muestra el recorrido En Orden del arbol  */
{
   busqueda (arbol,mm,aa);
}

turista* arbol::raiz (pnodo aux)
// Devuelve la raiz del arbol
{
 	return (aux->giri);
}

void arbol::inorden (pnodo aux)
/* Realiza un recorrido En Orden del arbol, es decir, primero el subarbol
   izquierdo, luego muestra la raiz y a continuacin el subarbol derecho */
{
 	if (!vacio(aux))
   {
     	inorden (aux->izq);
     	cout<<"TURISTA: "<<aux->giri->get_nombre()<<endl;
      cout<<"Nacionalidad: "<<aux->giri->get_nacionalidad()<<endl;
      aux->giri->mostrar_monumentos();
		aux->giri->imprime_fecha();
      getchar();
		inorden (aux->der);

   }
}

void arbol::busqueda (pnodo aux, char *mm, char *aa)
/* Realiza un recorrido En Orden del arbol, es decir, primero el subarbol
   izquierdo, luego muestra la raiz y a continuacin el subarbol derecho
   mostrando aquellos elementos que coinciden con los valores pasados */
{

	int d,m,a;
   char *mes,*anio;
   mes=new char[2];
   anio=new char[4];

 	if (!vacio(aux))
   {
	 	busqueda (aux->izq,mm,aa);

      aux->giri->get_fecha(d,m,a);
     	itoa (m,mes,10);
		itoa (a,anio,10);

      if (((strcmp(mm,mes))==0) && ((strcmp(aa,anio))==0))
      {
   		cout<<endl<<"El siguiente turista visito la ciudad el mes "<<mm<<" de "<<aa<<" :"<<endl;

      	cout<<"TURISTA: "<<aux->giri->get_nombre()<<endl;
      	cout<<"Nacionalidad: "<<aux->giri->get_nacionalidad()<<endl;
      	aux->giri->mostrar_monumentos();
			aux->giri->imprime_fecha();
        	getchar();
      }

		busqueda (aux->der,mm,aa);

   }

}

void arbol::guardar (char *fichet)
/* Muestra el recorrido En Orden del arbol  */
{
   apertura (arbol,fichet);
}

void arbol::apertura (pnodo auxi, char * fturi)
{
   ofstream turis(fturi); 		//Abrimos el fichero para lectura
	if (!turis)
	{
   	cout<<"Error al abrir el fichero de turistas "<<fturi<<endl;
      getchar();
      exit(1);
   }

   volcado(auxi,turis);

   turis.close();
}
void arbol::volcado (pnodo aux, ofstream &turistas)
/* Realiza un recorrido En Orden del arbol, es decir, primero el subarbol
   izquierdo, luego muestra la raiz y a continuacin el subarbol derecho */
{

	char * fila, *filam, *dia, *mes, *anio;
   fila=new char[1250];
   filam=new char[180];
	dia=new char[2];
   mes=new char[2];
   anio=new char[4];
	fila[0]='\0';
   filam[0]='\0';
   int d,m,a;

 	if (!vacio(aux))
   {
     	volcado (aux->izq,turistas);

      strcpy(fila,"\n");
   	strcat(fila,aux->giri->get_nombre());
   	strcat(fila,"#");
   	strcat(fila,aux->giri->get_nacionalidad());
   	strcat(fila,"#");

		aux->giri->get_fecha(d,m,a);
   	itoa (d,dia,10);
   	itoa (m,mes,10);
		itoa (a,anio,10);
   	strcat(fila,dia);
   	strcat(fila,"#");
   	strcat(fila,mes);
   	strcat(fila,"#");
   	strcat(fila,anio);
  	 	strcat(fila,"#");

      strcpy(filam,aux->giri->encadenar());
      strcat(fila,filam);

      turistas<<fila;

   	volcado (aux->der,turistas);

   }

}


bool arbol::hoja (pnodo aux)
/* Devuelve cierto si los subarboles derecho e izquierdo del arbol pasado
   por parametro estan vacios */
{
  	if ((aux -> der == NULL) && (aux -> izq == NULL)) return true;
   else return false;
}

int arbol::altura (pnodo aux)
/* Devuelve la altura del arbol pasado por valor */
{
   int prof;
   if (vacio(aux))	prof=0;
   else
   	{
     		prof = maximo (altura (aux -> izq), altura (aux -> der)) + 1;
     	}
	return prof;
}

int arbol::maximo (int n, int m)
/* Funcion auxiliar que devuelve el mximo entre dos enteros pasados por valor */
{
  	if (n > m) return n;
   else return  m;
}

bool arbol::buscanodo (pnodo aux, int dis)
/* Muestro los valores de los nodos situados a una distancia 'dis' de su
   hoja ms lejana. Devuelve falso si 'dis' es mayor que la altura del arbol */
{
  	int aux1, aux2;
  	if (!vacio(aux))
      {
       	aux1 = altura (aux->izq);
       	aux2 = altura (aux->der);

         if (maximo (aux1,aux2) < dis) return false;
         else
         {
           	if ((aux1==aux2) && (aux1==dis)) cout<<aux->giri ->get_nombre();
            else
            {
            	if (aux1 == dis) cout<<aux -> giri ->get_nombre()<<" ";
	         	else buscanodo(aux->izq,dis);
	        		if (aux2 == dis) cout<<aux -> giri ->get_nombre()<<" ";
	         	else buscanodo(aux->der,dis);
            }
            return true;
         }
      }
   else	return false;
}

void arbol::muestra_hojas (pnodo aux)
/* Realiza un recorrido en Post Orden hasta llegar a la hoja y la muesra por pantalla */
{
  	if (!hoja (aux))
      {
      	muestra_hojas (aux -> izq);
      	muestra_hojas (aux -> der);
      }
   else cout<<aux -> giri ->get_nombre()<<" ";
}

/*
Mtodo que escriba por pantalla los valores de todos los nodos que
tengan una distancia dada desde la raz (la distancia de la raz as misma es 0).
*/

void arbol::mostrar_nivel (int n)
/* Muestra el nivel del arbol pasado por valor */
{
  	if (!vacio(arbol))
  	{
    	if (n == 0)	cout<<raiz(arbol)<<" "<<endl;
      else
         {
         	hijoizq ().mostrar_nivel (n-1);
            hijoder ().mostrar_nivel (n-1);
         }
   }
}

/*
Implementa un mtodo que escriba por pantalla los valores de los nodos tales que
la distancia a sus hojas ms lejanas sea igual a un valor dado.
*/

void arbol::mostrar_nivel_inv (int n)
{
  	pnodo tree = arbol;
   buscanodo (tree,n);
}

arbol::~arbol()
{
	//cout<<"Ha entrado en el destructor arbol."<<endl;
}
