#include <alloc.h>
#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include <iostream.h>
#include <time.h>
#include <typeinfo.h>
#include <dos.h>
#include <fstream.h>
#include "turista.h"
#include "grafico.h"
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "coche.h"
#include "normal.h"
#include "rapido.h"
#include "objeto.h"
#include "bonificacion.h"
#include "estatua.h"
#include "vasija.h"
#include "bache.h"
#include "accidente.h"
#include "lista.h"
#include "segmento.h"
#include "cola.h"
#include "linea.h"
#include "grafo.h"
#include "arbol.h"
#include "juego.h"
#define MAX 6


juego::juego()
{
	cout<<"Ha entrado en el constructor juego"<<endl;
	getchar();
}

juego::~juego()
{
	cout<<"Ha entrado en el destructor juego"<<endl;
}

bool juego::choque(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4)
{
	// CONDICION DE CHOQUE DE LOS OBJETOS CON EL COCHE

	bool condicion1=false;
	bool condicion2=false;
  	bool condicion3=false;
 	bool condicion4=false;
	bool peligrox=false;
	bool peligroy=false;

	if ((x1<=x3) && (x3<=x2))	condicion1=true;	  	//Condicion1= si la x de la esquina superior izq del coche
   			                    							//est entre las esquinas del objeto a nivel x
   if ((x1<=x4) && (x4<=x2))	condicion2=true;	  	//Condicion2= si la x esquina inf der del coche
   			                    							//est entre las esquinas del objeto a nivel x
   if ((condicion1)||(condicion2))	peligrox=true;	//Si cualquier esquina del coche est entre las
                         									//esquinas del objeto existe peligro de choque
   	         												//en el eje x.
   if ((y1<=y3) && (y3<=y2))	condicion3=true;	  	//Condicion3= si la "y" de la esquina superior izq del coche
   			                    							//est entre las esquinas del objeto a nivel y
   if ((y1<=y4) && (y4<=y2))	condicion4=true;	  	//Condicion4= si la "y" esquina inferior der del coche
   									                     //est entre las esquinas del objeto a nivel y
   if ((condicion3)||(condicion4))	peligroy=true;	//Si cualquier esquina del coche est entre las
                          									//esquinas del objeto existe peligro de choque
   	         												//en el eje y.
   if ((peligrox)&&(peligroy))	return true;		//Si hay peligro de choque en ambos ejes
   	                    	                  		//existe choque
   else
   	{
      	condicion1=false;
	   	condicion2=false;
   		condicion3=false;
   		condicion4=false;
   		peligrox=false;
	   	peligroy=false;

      	if ((x3<=x1) && (x1<=x4))	condicion1=true; 		//Condicion1= si la esquina superior izq del obj
         		                    								//est entre las esquinas del coche a nivel x
	      if ((x3<=x2) && (x2<=x4))	condicion2=true; 		//Condicion2= si la esquina inf derecha del obj
         		                     							//est entre las esquinas del coche a nivel x
	      if ((condicion1)||(condicion2))	peligrox=true; //Si cualquier esquina del objeto est entre las
   	                          									//esquinas del coche existe peligro de choque
      		        													//en el eje x.
         if ((y3<=y1) && (y1<=y4))	condicion3=true; 		//Condicion3= si la esquina superior izq del objeto
         		 							                    	//est entre las esquinas del coche a nivel "y"
	      if ((y3<=y2) && (y2<=y4))	condicion4=true; 		//Condicion4= si la esquina inf der del objeto
	      		                    								//est entre las esquinas del coche a nivel "y"
         if ((condicion3)||(condicion4))	peligroy=true;	//Si cualquier esquina del objeto est entre las
	                            									//esquinas del coche existe peligro de choque
   	   	         												//en el eje y.
         if ((peligrox)&&(peligroy))	return true;
         else	return false;
      }
   		/** FIN DE CONDICION DE CHOQUE DE LOS OBJETOS CON EL COCHE **/
}

void juego::comp_choque(coche *pc, clock_t &start_parada, lista<segmento> *lista_seg, int &c, bool &sw, int &puntuacion, int &tiempo)
{
			int x1,y1,x2,y2,x3,y3,x4,y4;

   		/*COLISIN DEL COCHE CON LOS OBJETOS*/

         bool encontrado=false;
         objeto *p_obj, *item;
         segmento *p_seg;
         figura *p_fig;
         lista<objeto> *list_obj;
         lista<objeto> *list_ext;

         p_fig=pc->darcarroceria();
  			pc->calcularc(p_fig);

         x3=pc->get_x3();
   		y3=pc->get_y3();
   		x4=pc->get_x4();
   		y4=pc->get_y4();

   		lista_seg->iniciar();
         while(lista_seg->noesfin())			  	//Recorremos la lista buscando choques
            {
     				p_seg = lista_seg->leer();      	//leemos segmento de la lista
		   		list_obj = p_seg->darlista();   	//obtenemos la lista de objetos
		   		list_obj->iniciar();
		   		while (list_obj->noesfin())     	//Recorremos la lista de objetos
     					{
	   	  				p_obj=list_obj->leer();   	//Leemos un objeto
                     p_fig=p_obj->darforma();  	//Obtenemos su forma

                     p_obj->calcular(p_fig);   	//Calculamos las coordenadas del
                                               	//rectangulo que contiene la figura
	   					x1=p_obj->get_x1();
   						y1=p_obj->get_y1();		//Obtenemos las coordenadas del objeto
   						x2=p_obj->get_x2();     //(x1,y1),(x2,y2)
   						y2=p_obj->get_y2();

                     // CONDICIONES DE COLISIN DEL COCHE CON OBJETOS

                     if (choque(x1,y1,x2,y2,x3,y3,x4,y4))				//Llama a la funcin choque para comprobar si ha habido una colisin
                     	{
                        	if (typeid(*(p_obj))==typeid(accidente))
                                             {
                        						    	start_parada=clock();
								   	                  sw=false;
                                                p_obj->borrar();
                                                tiempo=((accidente *)p_obj)->get_tiempo();
                                             }	//fin condicin accidente

                           else if (typeid(*(p_obj))==typeid(bache))
                           		{
                                 	list_ext=pc->darextras();	//Obtenemos la lista de bonificaciones
                                    encontrado=false;

                                    if (!list_ext->vacia())
                                    	{
                                       	list_ext->iniciar();
                                          while ((list_ext->noesfin())&&(!encontrado))
                                          	{
                                                item=list_ext->leer();						//leemos un item de la lista de bonificaciones
                                                if (typeid(*(item))==typeid(estatua))  //Verificamos si es una estatua
                                                	{
                                                      list_ext->eliminar_actual();	//Borramos la estatua de la lista
                                                      encontrado=true;           	//item encontrado
                                                   }
                                                else
                                                  	{
                                                  		list_ext->avanzar();                //Si no se encuentra avanzamos
                                                   }
                                             }
                                       }

                                    if (!encontrado)	c=27;

                                    p_obj->borrar();

                                 }	//fin condicin bache

            							else if (typeid(*(p_obj))==typeid(estatua))
                       	 				  {
                                               	list_ext=pc->darextras();
                                              	item=new estatua(*((estatua *)p_obj));   	//copiando objeto estatua
                                              	list_ext->insertar(item);
																puntuacion=puntuacion+((bonificacion *)p_obj)->get_puntos();
                                                p_obj->borrar();

     												}			//fin condicin estatua

                                      else if (typeid(*(p_obj))==typeid(vasija))
                        						 {
                                          	   list_ext=pc->darextras();
                                             	item=new vasija(*((vasija *)p_obj));   	//copiando objeto estatua
            												list_ext->insertar(item);
                                             	puntuacion=puntuacion+((bonificacion *)p_obj)->get_puntos();
                                                p_obj->borrar();

                                            }	//fin condicin vasija

	                        list_obj->eliminar_actual();

                        } 		//** FIN DE CONDICION DE CHOQUE DEL COCHE **

                        else  //Si no choca avanza al siguiente objeto del segmento
                        {
                  			list_obj->avanzar();
                        }

                  }		//fin while lectura lista objetos

                  lista_seg->avanzar();	//Avanza al siguiente segmento
            }
}

bool juego::carrera(char * file,grafo *gra,coche *p_coche, turista *t)
{
	gotoxy(1,6);
   cout<<"CALLE: "<<file<<endl;
   linea *lin=new linea();					//Puntero linea

   char *cadena;              			//Puntero a cadena

   fstream fiche(file,ios::in); 			//Abrimos el fichero para lectura
	if (!fiche)
	{
   	cout<<"Error al abrir el fichero."<<file;
      getchar();
      exit(1);
   }
   if ((cadena=new char[80])==NULL)
   {
   	cout<<"Error en la reserva de memoria.";
		getchar();
      exit(1);
   }
   bool completado=false;	//Carrera completada
   bool encontrado=false;
   cadena[0]='\0';
   int cont=0;
   int cuenta_seg=0;
   int col,xs,ys,xi,yi,xx,yy,cod_seg,litros,puntos,gasoil,tiempo;
   int contenido=0;
   int puntuacion=0;
   segmento *p_seg,*copia_seg;
   objeto *p_obj, *item;
   char *qes;								//Contenido del campo 3 de fiche (tipo objeto)
	figura *kretera,*p_fig;
   lista<objeto> *list_obj, *list_ext;

   while ((!fiche.eof()) && (cont<5))		//Sacamos las primeras 5 lineas
   {
   	fiche>>cadena;                      //lee una lnea del fichero
   	lin->separar(cadena);               //separa los campos marcados por #

   	if (cont==0) 	col=atoi(lin->obtener_campo(0));	//1 lnea=color
      if (cont==1) 	xs=atoi(lin->obtener_campo(0));  //2 lnea=x superior
      if (cont==2)	ys=atoi(lin->obtener_campo(0));  //3 lnea=y superior
      if (cont==3) 	xi=atoi(lin->obtener_campo(0));  //4 lnea=x inferior
      if (cont==4) 	yi=atoi(lin->obtener_campo(0));  //5 lnea=y inferior

    	cont=cont++;	//se incrementa el contador de lneas
   }

   cola<segmento> *p_cola;
   p_cola=new cola<segmento>();

   int cod=1;

   fiche>>cadena;									//lee la 1 cadena del fichero

   lin->separar(cadena); 						//separa los campos de la cadena leida
   cod_seg=atoi(lin->obtener_campo(0));   //1 campo=nmero del segmento

   while (!fiche.eof())                   		//mientras no sea fin de fichero
   {
      p_seg=new segmento(xs,ys,col,xi,yi);		//creamos nuevo segmento con parametros del fichero
      list_obj=p_seg->darlista();					//da el puntero a lista obj de seg

      while ((cod_seg==cod) && (!fiche.eof()))	//Mientras el campo de segmento sea = q cod,
      {                                         //significa que es un objeto del segmento con ese cod
         qes=(lin->obtener_campo(2));           //El campo 3 indica que tipo de objeto es
         xx=atoi(lin->obtener_campo(3))+xs;
      	yy=atoi(lin->obtener_campo(4))+ys;

         if (strcmp(qes,"bache")==0)					//Compara el 3 campo con la cadena "bache"
         	{
            	p_obj=new bache(xx,yy);					//crea un objeto bache con parametros de fichero
               list_obj->insertar(p_obj);          //lo inserta en la lista de objetos del segmento
            }
         if (strcmp(qes,"accidente")==0)           //Compara el 3 campo con la cadena "accidente"
         	{
            	tiempo=atoi(lin->obtener_campo(5));	//tiempo inmovilizado el coche
            	p_obj=new accidente(xx,yy,tiempo); 	//crea un objeto accidente
               list_obj->insertar(p_obj);          //inserta el objeto
            }
         if (strcmp(qes,"estatua")==0)             //Compara el 3 campo con la cadena "estatua"
         	{
            	puntos=atoi(lin->obtener_campo(5)); //Puntos que da esa bonificacion
            	p_obj=new estatua(xx,yy,puntos);    //crea un objeto estatua
               list_obj->insertar(p_obj);
            }
         if (strcmp(qes,"vasija")==0)				 	//Compara el 3 campo con la cadena "vasija"
         	{
            	puntos=atoi(lin->obtener_campo(5));    //Puntos que da esa bonificacion
            	litros=atoi(lin->obtener_campo(6));    //Litros de gasolina que repostar
               p_obj=new vasija(xx,yy,puntos,litros);	//crea un objeto vasija
               list_obj->insertar(p_obj);
            }

         fiche>>cadena;                                  //Lee lnea del fichero

         lin->separar(cadena);                           //Separa la lnea en campos
	      cod_seg=atoi(lin->obtener_campo(0));            //Obtiene el campo del cod de segmento (1)

      }	//Fin while cod_seg==cod

      p_cola->encolar(p_seg);                            //Inserta el segmento en la cola

      cod++;                                             //Incrementa cod al cdigo del siguiente segmento

   }	//Fin while not eof fiche

  	fiche.close();								//Cerramos el fichero

   delete lin;
   delete cadena;

   lista<segmento> *lista_seg;			//Creamos un puntero a una lista de segmentos
   lista_seg=new lista<segmento>();    //Creamos la lista
   lista_seg->crear_lista();

   p_coche->set_vel_horiz(gra->get_vel_horiz());	//Inicializamos la velocidad dada por el fichero q lee grafo
   p_coche->set_gasolina(gra->get_gasolina());		//Inicializamos la gasolina dada por el fichero q lee grafo

   p_coche->pintar();                //Pintamos el coche

   clock_t start, end, start_parada, end_parada;

   start = clock();		//Tomamos el tiempo

   int c;  					//C tomar el valor recogido por teclado

   //BUCLE INFINTO QUE MUESTRA LA CARRETERA EN MOVIMIENTO

   bool sw=true;        //SW=true indica que no hay accidentes

   while (true)
   {
   	if (sw)           //Si sw=true no hay accidentes y se leen las pulsaciones
    	 {
        if (kbhit())   				//Si se pulsa una tecla ...
     		{

     		c=getch();           	//... se almacena en la variable c ...
         p_coche->mover(c);    //... se mueve el coche en funcin de la tecla.

         comp_choque(p_coche, start_parada, lista_seg, c, sw, puntuacion, tiempo);	//Comprueba que tipo de objeto choc en caso de producirse un choque

         }
       }
      else  		//Si sw no es true, es decir si hay un accidente
       {
        	end_parada=clock();																//Tomamos tiempo fin de parada
         if (((end_parada - start_parada) / CLK_TCK)>tiempo)  sw=true;     //Si el fin de parada-el inicio supera el tiempo del accidente sw=true (no hay accidente).
       }

     	end = clock();

     	if (((end - start) / CLK_TCK)>2)        //Si han pasado mas de 2 segundos
         {

        	//COPIA DE SEG. DE LA COLA SEGMENTOS, QUE SE INSERTAN EN LISTA SEG.

	   		if (!(p_cola->cola_vacia()))			//Mientras tenga segmentos la cola
   			{
            	p_seg=p_cola->primero();         	//Sacamos el primer elemento de la cola
      			copia_seg=new segmento(*(p_seg));   //copiamos el segmento
      			lista_seg->insertar(copia_seg);		//enlistamos el seg. copiado
      			p_cola->desencolar();            	//Desencolamos el seg. y lo borramos
         	}

         //BORRADO DE SEGMENTO

         	lista_seg->iniciar();
         	while(lista_seg->noesfin())
     			{
     				p_seg = lista_seg->leer();       //leemos segmento de la lista
		   		kretera = p_seg->darcarretera(); //obtenemos la forma de la carretera
            	kretera->borrar();               //pintamos la carretera
               list_obj = p_seg->darlista();    //obtenemos la lista de objetos
		   		list_obj->iniciar();

		   		while (list_obj->noesfin())      //pintamos todos los objetos de la lista
     					{
	     					p_obj=list_obj->leer();
                  	p_obj->borrar();
   						list_obj->avanzar();
     					}
               lista_seg->avanzar();
           	}

         //DESPLAZAMIENTO DE SEGMENTOS

         	lista_seg->iniciar();
         	while(lista_seg->noesfin())
            {
            	p_seg=lista_seg->leer();
               kretera=p_seg->darcarretera();
               list_obj=p_seg->darlista();
               kretera->set_y(kretera->get_y()-ys);

         		((rectangulo *)kretera)->set_endy(((rectangulo *)kretera)->get_endy()-ys);

					list_obj->iniciar();					//iniciamos el recorrido de lista objetos
   				while (list_obj->noesfin())      //hasta que termine lista objetos
     					{
	     					p_obj=list_obj->leer();							//bajamos la posicin de los objetos
               		p_fig=p_obj->darforma();         			//obtenemos la forma del objeto
         				p_fig->set_y(p_fig->get_y()-ys);          //Se toma la Y q se dio a fig en el constuctor y se desplaza el ancho del segmento (valor -)
               		if (typeid(*(p_fig))==typeid(rectangulo))
               			((rectangulo *)p_fig)->set_endy(((rectangulo *)p_fig)->get_endy()-ys);   //Si es un rectangulo tambien se incrementan las (x,y) inferiores
     						list_obj->avanzar();
     					}

            lista_seg->avanzar();

            }

         //PINTA MARCADOR

            gotoxy(1,1);
            cout<<"PUNTOS: "<<puntuacion;
            gotoxy(1,2);
            cout<<"             ";
            gotoxy(1,2);
            cout<<"GASOLINA: "<<p_coche->get_gasolina();
            gotoxy(1,8);
            cout<<"                  ";
            gotoxy(1,8);
            cout<<"VASIJAS: ";

            list_ext=p_coche->darextras();		//Obtenemos la lista de bonificaciones
            list_ext->iniciar();                //La inicializamos
            while (list_ext->noesfin())         //Hasta que no se acabe la lista
            	{
                 	p_obj=list_ext->leer();                          	//Leemos objeto
                  if (typeid(*(p_obj))==typeid(vasija))	cout<<"*";  //Si es una vasija pintamos *
                  list_ext->avanzar();                               //Siguiente
               }

				gotoxy(1,9);
            cout<<"                ";
            gotoxy(1,9);
            cout<<"ESTATUAS: ";
            list_ext->iniciar();                //Iniciamos la lista de bonificaciones
            while (list_ext->noesfin())
            	{
                	p_obj=list_ext->leer();                            //Leemos
                  if (typeid(*(p_obj))==typeid(estatua))	cout<<"@";  //Si es una vasija pintamos @
                  list_ext->avanzar();                               //Siguiente
					}


         //PINTA LOS SEGMENTOS DE LA LISTA

   			lista_seg->iniciar();
         	while(lista_seg->noesfin())
            {
     				p_seg = lista_seg->leer();       //leemos segmento de la lista
		   		kretera = p_seg->darcarretera(); //obtenemos la forma de la carretera
               //kretera->set_color(col);          //Pone color
		   		kretera->pintar();               //pintamos la carretera
		   		list_obj = p_seg->darlista();    //obtenemos la lista de objetos
		   		list_obj->iniciar();
		   		while (list_obj->noesfin())      //pintamos todos los objetos de la lista
     					{
                  	p_obj=list_obj->leer();
         				p_fig=p_obj->darforma();
                     p_obj->pintar();
                     list_obj->avanzar();
     					}
               lista_seg->avanzar();
				}

            comp_choque(p_coche, start_parada, lista_seg, c, sw, puntuacion, tiempo);


         //ELIMINA EL SEG. DE LA LISTA QUE SE SALE DE LA PANTALLA

         	lista_seg->iniciar();
         	p_seg = lista_seg->leer();       //leemos segmento de la lista
		   	kretera = p_seg->darcarretera(); //obtenemos la forma de la carretera
         	if ((kretera->get_y())>=480)
   				{
            		lista_seg->eliminar(p_seg);   //borra 1 segmento de la lista>480
                  cuenta_seg++;
                  if ((cuenta_seg%3)==0)
                  	{
                  			p_coche->set_gasolina(p_coche->get_gasolina()-10);
                           gasoil=p_coche->get_gasolina();
                           if (gasoil<=20)
                           	{
                              	contenido=0;
                              	list_ext=p_coche->darextras();
                                 if (!list_ext->vacia())
                                 {
                                 	encontrado=false;
                                    list_ext->iniciar();
                                 	while (list_ext->noesfin())
                                   	{
                                    	item=list_ext->leer();

                                       if ((typeid(*(item))==typeid(vasija))&&(!encontrado))
                                          	{
                                             	contenido=((vasija *)item)->get_litros();
                                                list_ext->eliminar_actual();
                                                encontrado=true;
                                          	}

                                    	else  list_ext->avanzar();

                                    }

                                    if ((p_coche->get_gasolina()+contenido)>50)
                                    	{
                                    		p_coche->set_gasolina(50);
                                    	}
                                    else
                                    	{
                                    		p_coche->set_gasolina(p_coche->get_gasolina()+contenido);
                                    		gasoil=p_coche->get_gasolina();
                                    	}
                                 } //fin if list_ext no vacia

                                 if ((gasoil<=0) && (contenido==0))
						                  	{
                                       	gotoxy(1,2);
                     							cout<<"             ";
                 	                        gotoxy(1,2);
                     							cout<<"GASOLINA: "<<p_coche->get_gasolina();
                  						     	gotoxy(1,3);
                     							cout<<"PUNTUACION: "<<t->get_puntos();
                        						gotoxy(1,4);
                     							cout<<"FALTA GASOLINA"<<endl;
                      						  	c=27;
                                      	}

                              }		//Fin if gasoil<20
                     } 				//Fin if cuenta_seg%3

                  if (lista_seg->vacia())
         				{
                     	gotoxy(1,1);
                     	cout<<"PUNTOS: "<<puntuacion;
                        t->set_puntos(t->get_puntos()+puntuacion);
                        gotoxy(1,3);
                     	cout<<"PUNTUACION: "<<t->get_puntos();
                        gotoxy(1,2);
                        cout<<"             ";
                     	gotoxy(1,2);
                        cout<<"GASOLINA: "<<p_coche->get_gasolina();
                        //getchar();
                        completado=true;
                        c=27;							//fin de la carretera
         				}
              	} //fin if carretera>480

     		start=clock();               		//tomamos el tiempo

         }  //Fin if han pasado 3 seg.

   if (kbhit()) c = getch();					//si se pulsa una tecla se captura
   if (c==27)										//si se  pulsa escape
    {
    	break;
    }
   }	//Fin while true


   c=0;

   delete lista_seg;

   delete p_cola;

   return completado;
}

void juego::cargar_carrera(grafico *g1, grafo *gr, coche *p_coche, turista *turi, int j, bool visitados[])
{
	int posi;
	char *kalle, *origen, *destino;

        origen=gr->get_p_origen();
        destino=gr->get_p_vn(j);
		  g1->borramenu();
        if (!(gr->existe_arco(origen,destino)))
        	{
         	gotoxy (11,11);
         	cout<<"No existe camino entre "<<origen<<" y "<<destino<<endl;
            getchar();
            g1->pintagrafo(gr);
         }
        else
        	{
				posi=gr->posicion_origen();
            kalle=new char[strlen(gr->get_calle(posi,j))+5];
        		strcpy(kalle,gr->get_calle(posi,j));
            strcat(kalle,".txt\0");
            if (carrera(kalle,gr,p_coche,turi))
            							{
                                 	gotoxy (1,6);
                                    cout<<"FINISH"<<endl;
                                    gr->set_p_origen(j);
                                    origen=gr->get_p_origen();
                                    if (!(visitados[j]))
                                    	{
                                          visitados[j]=true;
														turi->set_monumento(gr->get_nodo(j));
                                       }
                                 }
            else
            	{
               	gotoxy (1,5);
               	cout<<"GAME OVER"<<endl;
                  gotoxy (1,6);
               	cout<<"INSERT COIN        "<<endl;
               }
            getchar();
            delete kalle;
         }
}

coche * juego::eligecoche(coche *pc_normal, coche *pc_rapido, turista *turi, bool &creado_r)
{

   objeto *obj,*bonificacion;    		//Punteros a objetos
   lista<objeto> *lista_b;             //Puntero a lista de bonificaciones
   cola<objeto> *cola_b;               //Puntero a una cola de bonificaciones

   cola_b=new cola<objeto>();        	//cola de objetos.
   lista_b=new lista<objeto>();        //lista de objetos.

   if (turi->get_puntos()<1000)		return pc_normal;	//Si puntos<1000 devuelve puntero a coche normal

   if ((turi->get_puntos()>=1000) && (!creado_r))  //Si puntos>1000 y nunca se creo coche rapido
   	{
      	lista_b=pc_normal->darextras();

         lista_b->iniciar();
         while (lista_b->noesfin())     	//Recorremos la lista de bonificaciones
         	{
            	obj=lista_b->leer();
               if (typeid(*(obj))==typeid(estatua))		bonificacion=new estatua(*((estatua *)obj));   	//copiando objeto estatua
               else if (typeid(*(obj))==typeid(vasija))		bonificacion=new vasija(*((vasija *)obj));   //copiando objeto estatua
               cola_b->encolar(bonificacion);
               lista_b->avanzar();
            }

         //cout<<"borra p_coche normal"<<endl;

         lista_b=pc_rapido->darextras();    		//Da la lista de bonificaciones
         while (!(cola_b->cola_vacia()))			//Mientras tenga bonificaciones la cola
   			{
         	  	obj=cola_b->primero();         																				//Sacamos el primer elemento de la cola
      			if (typeid(*(obj))==typeid(estatua))		bonificacion=new estatua(*((estatua *)obj));   	//copiando objeto estatua
               else if (typeid(*(obj))==typeid(vasija))	bonificacion=new vasija(*((vasija *)obj));   	//copiando objeto vasija
              	lista_b->insertar(bonificacion);
               cola_b->desencolar();
            }

         creado_r=true;
         return pc_rapido;		//Devuelve puntero a coche rapido
      }

   if ((turi->get_puntos()>=1000) && (creado_r))   return pc_rapido;
}

