#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include "lista.h"
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "objeto.h"
#include "bonificacion.h"
#include "estatua.h"
#include "vasija.h"
#include "bache.h"
#include "accidente.h"
#ifndef coche_h
#define coche_h

class coche
{
	protected:

   	int x; 						//coordenada x
      int y; 						//coordenada y
      int x3,y3,x4,y4;			//coordenadas de los extremos del rectangulo q bordea la carroceria
      figura *v_figuras[7];	//vector de siete figuras 4 ruedas, 2 faros, 1 carroceria
      int vel_horiz;				//velocidad horizontal
      int gasolina;           //gasolina
      lista<objeto> *extras;	//lista de bonificaciones recogidas (estatuas y vasijas)

   public:

   	coche(int x,int y);						//Constructor con parametros
  		lista<objeto> * darextras();        //Da la lista de bonificaciones del coche
		figura * darcarroceria();				//Obtiene la figura de la carroceria v[6]
      void calcularc(figura * figu);      //Calcula las coordenadas del rectngulo contenedor
      void set_gasolina(int gasolina);    //Inicializa el atributo gasolina
      int get_gasolina();                 //Obtiene la gasolina que tiene el coche
      void set_vel_horiz(int vel_horiz);  //Inicializa la velocidad horizontal
      int get_vel_horiz();                //Obtiene la velocidad horizontal
      int get_x3();                       //Obtiene las coordenadas del rectangulo contenedor
      int get_y3();
      int get_x4();
      int get_y4();
      virtual void pintar()=0;            //pintar coche
      virtual void borrar()=0;            //borrar coche
      virtual void mover(int tecla)=0;    //mover coche
      virtual ~coche();     					//destructor

};

#endif
