#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"
#include "elipse.h"
#include "coche.h"
#include "normal.h"

normal::normal(int x, int y):coche(x,y)
{
	//cout<<"Ha entrado en el contructor coche normal sin parametrizar";
   //getchar();

	this->x=x;
   this->y=y;

   v_figuras[0]=new circulo(x-25,y-30,8,10);
   v_figuras[1]=new circulo(x+25,y-30,8,10);
   v_figuras[2]=new circulo(x-25,y+30,8,10);
   v_figuras[3]=new circulo(x+25,y+30,8,10);
   v_figuras[4]=new elipse(x-15,y-50,14,0,360,10,5);
   v_figuras[5]=new elipse(x+15,y-50,14,0,360,10,5);
   v_figuras[6]=new rectangulo(x-25,y-50,1,x+25,y+50);

   v_ruedas_extras[0]=new circulo(x-25,y,8,10);
   v_ruedas_extras[1]=new circulo(x+25,y,8,10);

	vel_horiz=10;
}

normal::~normal()
{
	//cout<<"Ha entrado en el destructor coche normal";
   //getchar();

	for (int i=0;i<7;i++)	delete v_figuras[i];
   for (int i=0;i<2;i++)	delete v_ruedas_extras[i];
}

void normal::operator --(void)
{
	cout<<"Operador sobrecargado -- "<<endl;
   v_figuras[1]->set_color(0);
   v_figuras[1]->pintar();
}

void normal::pintar()
{
	//cout<<"Ha entrado en el metodo pintar coche normal";
   //getchar();

   for (int i=0; i<7;i++)  	v_figuras[i]->pintar();
   for (int i=0; i<2;i++)		v_ruedas_extras[i]->pintar();
}

void normal::borrar()
{
	//cout<<"Ha entrado en el metodo borrar coche normal";
   //getchar();
   for (int i=0; i<7;i++)		v_figuras[i]->borrar();
   for (int i=0; i<2;i++)		v_ruedas_extras[i]->borrar();
}

void normal::mover(int tecla)
{
	//cout<<"Ha entrado en el metodo mover coche normal";

   borrar();   						//Borrar coche
   if (tecla==77)
   	{
   		if (x<590)						//Tecla derecha
   					{
                  	x=x+vel_horiz;
                  	for (int i=0; i<7;i++)
                     								{
                                            		v_figuras[i]->set_x(v_figuras[i]->get_x()+vel_horiz);
                                             }
                     ((rectangulo *)v_figuras[6])->set_endx(((rectangulo *)v_figuras[6])->get_endx()+vel_horiz);
                     for (int i=0; i<2; i++) v_ruedas_extras[i]->set_x(v_ruedas_extras[i]->get_x()+vel_horiz);
                   }
      }
   if (tecla==75)			//Tecla izquierda
   	{
   		if (x>210)
   					{
                  	x=x-vel_horiz;
                  	for (int i =0; i<7;i++)
                     								{
                                             	v_figuras[i]->set_x(v_figuras[i]->get_x()-vel_horiz);
                                             }
                     ((rectangulo *)v_figuras[6])->set_endx(((rectangulo *)v_figuras[6])->get_endx()-vel_horiz);
                     for (int i=0; i<2; i++) v_ruedas_extras[i]->set_x(v_ruedas_extras[i]->get_x()-vel_horiz);

                  }
      }
   pintar();
}
