#ifndef cola_h
#define cola_h

 	#include <iostream.h>
   #include <stdio.h>
   #include <stdlib.h>
   #include <conio.h>

   template <class datos_cola>
   class cola
   {
      private:

         struct nodo
         {
            datos_cola *info;
            struct nodo *siguiente;
         };

         typedef struct nodo *ptrnodo;

         ptrnodo  inicio, fin;

      public:

      	cola ();
         void encolar (datos_cola *d);
         datos_cola* primero ();
         void desencolar ();
         bool cola_vacia ();
         void borradototal ();
         ~cola ();
	};

         template <class datos_cola>
			cola <datos_cola> :: cola ()
         {
    			  inicio = NULL;
              fin = NULL;
   		}

         template <class datos_cola>
         void cola <datos_cola> :: encolar (datos_cola *d)
         {
      		ptrnodo nuevo;
      		if ((nuevo = new nodo) == NULL)
      		{
         		cout <<"error en la asignacion de memoria";
         		exit (0);
      		}
      		(*nuevo).info = d;
		      if (cola_vacia ())
      		{
         		inicio = nuevo;
         		fin = nuevo;
      		}
      		else
      		{
         		fin -> siguiente = nuevo;
         		fin = nuevo;
         		fin -> siguiente = NULL;
      		}
   		}

         template <class datos_cola>
         datos_cola* cola <datos_cola> :: primero ()
		   {
      		return inicio -> info;
   		}

         template <class datos_cola>
         void cola <datos_cola> :: desencolar ()
		   {
         	ptrnodo primero = NULL;
            primero = inicio;
            inicio = inicio -> siguiente;
            delete primero;
      	}

         template <class datos_cola>
         bool cola <datos_cola> :: cola_vacia ()
		   {
      		return (inicio == NULL);
   		}

         template <class datos_cola>
         void cola <datos_cola> :: borradototal ()
		   {
      		//cout << "destruyendo cola...\n";
      		ptrnodo aux;
      		while (!cola_vacia ())
      		{
         		aux = inicio -> siguiente;
         		delete inicio;
         		inicio = aux;
      		}
		      inicio = NULL;
      		fin = NULL;
      		//cout <<"cola destruida..."<<endl;
      		//getchar ();
   		}

         template <class datos_cola>
         cola <datos_cola>::~cola()
         {
				borradototal();
         }

#endif
